diff --git a/test/functional/api/v1/config_templates_controller_test.rb b/test/functional/api/v1/config_templates_controller_test.rb
index e4f1d9f46..041609d28 100644
--- a/test/functional/api/v1/config_templates_controller_test.rb
+++ b/test/functional/api/v1/config_templates_controller_test.rb
@@ -5,7 +5,7 @@ class Api::V1::ConfigTemplatesControllerTest < ActionController::TestCase
   test "should get index" do
     get :index
     templates = ActiveSupport::JSON.decode(@response.body)
-    assert !templates.empty?, "Should response with template"
+    assert_not_empty templates
     assert_response :success
   end
 
@@ -13,13 +13,13 @@ class Api::V1::ConfigTemplatesControllerTest < ActionController::TestCase
     get :show, { :id => config_templates(:pxekickstart).to_param }
     assert_response :success
     template = ActiveSupport::JSON.decode(@response.body)
-    assert !template.empty?
+    assert_not_empty template
     assert_equal template["config_template"]["name"], config_templates(:pxekickstart).name
   end
 
   test "should not create invalid" do
     post :create
-    assert_response 422
+    assert_response :unprocessable_entity
   end
 
   test "should create valid" do
@@ -28,13 +28,13 @@ class Api::V1::ConfigTemplatesControllerTest < ActionController::TestCase
     post :create, { :config_template => valid_attrs }
     template = ActiveSupport::JSON.decode(@response.body)
     assert template["config_template"]["name"] == "RandomName"
-    assert_response 200
+    assert_response :success
   end
 
   test "should not update invalid" do
     put :update, { :id              => config_templates(:pxekickstart).to_param,
                    :config_template => { :name => "" } }
-    assert_response 422
+    assert_response :unprocessable_entity
   end
 
   test "should update valid" do
@@ -42,13 +42,13 @@ class Api::V1::ConfigTemplatesControllerTest < ActionController::TestCase
     put :update, { :id              => config_templates(:pxekickstart).to_param,
                    :config_template => { :template => "blah" } }
     template = ActiveSupport::JSON.decode(@response.body)
-    assert_response :ok
+    assert_response :success
   end
 
   test "should not destroy template with associated hosts" do
     config_template = config_templates(:pxekickstart)
     delete :destroy, { :id => config_template.to_param }
-    assert_response 422
+    assert_response :unprocessable_entity
     assert ConfigTemplate.exists?(config_template.id)
   end
 
@@ -57,7 +57,7 @@ class Api::V1::ConfigTemplatesControllerTest < ActionController::TestCase
     config_template.os_default_templates.clear
     delete :destroy, { :id => config_template.to_param }
     template = ActiveSupport::JSON.decode(@response.body)
-    assert_response :ok
+    assert_response :success
     assert !ConfigTemplate.exists?(config_template.id)
   end
 
@@ -65,7 +65,7 @@ class Api::V1::ConfigTemplatesControllerTest < ActionController::TestCase
     ProxyAPI::TFTP.any_instance.stubs(:create_default).returns(true)
     ProxyAPI::TFTP.any_instance.stubs(:fetch_boot_file).returns(true)
     get :build_pxe_default
-    assert_response 200
+    assert_response :success
   end
 
   test "should add audit comment" do
diff --git a/test/functional/api/v1/hosts_controller_test.rb b/test/functional/api/v1/hosts_controller_test.rb
index dcdf964b2..46d0b9676 100644
--- a/test/functional/api/v1/hosts_controller_test.rb
+++ b/test/functional/api/v1/hosts_controller_test.rb
@@ -21,14 +21,14 @@ class Api::V1::HostsControllerTest < ActionController::TestCase
     assert_response :success
     assert_not_nil assigns(:hosts)
     hosts = ActiveSupport::JSON.decode(@response.body)
-    assert !hosts.empty?
+    assert_not_empty hosts
   end
 
   test "should show individual record" do
     get :show, { :id => hosts(:one).to_param }
     assert_response :success
     show_response = ActiveSupport::JSON.decode(@response.body)
-    assert !show_response.empty?
+    assert_not_empty show_response
   end
 
   test "should create host" do
@@ -74,72 +74,64 @@ class Api::V1::HostsControllerTest < ActionController::TestCase
   end
 
   test "should allow access to restricted user who owns the host" do
-    as_user :restricted do
-      get :show, { :id => hosts(:owned_by_restricted).to_param }
-    end
+    setup_user 'view', 'hosts', "owner_type = User and owner_id = #{users(:restricted).id}", :restricted
+    $debug = true
+    get :show, { :id => hosts(:owned_by_restricted).to_param }
     assert_response :success
   end
 
   test "should allow to update for restricted user who owns the host" do
     disable_orchestration
-    as_user :restricted do
-      put :update, { :id => hosts(:owned_by_restricted).to_param, :host => {} }
-    end
+    setup_user 'edit', 'hosts', "owner_type = User and owner_id = #{users(:restricted).id}", :restricted
+    put :update, { :id => hosts(:owned_by_restricted).to_param, :host => {} }
     assert_response :success
   end
 
   test "should allow destroy for restricted user who owns the hosts" do
     assert_difference('Host.count', -1) do
-      as_user :restricted do
-        delete :destroy, { :id => hosts(:owned_by_restricted).to_param }
-      end
+      setup_user 'destroy', 'hosts', "owner_type = User and owner_id = #{users(:restricted).id}", :restricted
+      delete :destroy, { :id => hosts(:owned_by_restricted).to_param }
     end
     assert_response :success
   end
 
   test "should allow show status for restricted user who owns the hosts" do
-    as_user :restricted do
-      get :status, { :id => hosts(:owned_by_restricted).to_param }
-    end
+    setup_user 'view', 'hosts', "owner_type = User and owner_id = #{users(:restricted).id}", :restricted
+    get :status, { :id => hosts(:owned_by_restricted).to_param }
     assert_response :success
   end
 
   test "should not allow access to a host out of users hosts scope" do
-    as_user :restricted do
-      get :show, { :id => hosts(:one).to_param }
-    end
+    setup_user 'view', 'hosts', "owner_type = User and owner_id = #{users(:restricted).id}", :restricted
+    get :show, { :id => hosts(:one).to_param }
     assert_response :not_found
   end
 
   test "should not list a host out of users hosts scope" do
-    as_user :restricted do
-      get :index, {}
-    end
+    setup_user 'view', 'hosts', "owner_type = User and owner_id = #{users(:restricted).id}", :restricted
+    get :index, {}
     assert_response :success
     hosts = ActiveSupport::JSON.decode(@response.body)
     ids = hosts.map { |hash| hash['host']['id'] }
-    assert !ids.include?(hosts(:one).id)
-    assert ids.include?(hosts(:owned_by_restricted).id)
+    refute_includes ids, hosts(:one).id
+    assert_includes ids, hosts(:owned_by_restricted).id
   end
 
   test "should not update host out of users hosts scope" do
-    as_user :restricted do
-      put :update, { :id => hosts(:one).to_param }
-    end
+    setup_user 'edit', 'hosts', "owner_type = User and owner_id = #{users(:restricted).id}", :restricted
+    put :update, { :id => hosts(:one).to_param }
     assert_response :not_found
   end
 
   test "should not delete hosts out of users hosts scope" do
-    as_user :restricted do
-      delete :destroy, { :id => hosts(:one).to_param }
-    end
+    setup_user 'destroy', 'hosts', "owner_type = User and owner_id = #{users(:restricted).id}", :restricted
+    delete :destroy, { :id => hosts(:one).to_param }
     assert_response :not_found
   end
 
   test "should not show status of hosts out of users hosts scope" do
-    as_user :restricted do
-      get :status, { :id => hosts(:one).to_param }
-    end
+    setup_user 'view', 'hosts', "owner_type = User and owner_id = #{users(:restricted).id}", :restricted
+    get :status, { :id => hosts(:one).to_param }
     assert_response :not_found
   end
 
diff --git a/test/functional/api/v1/smart_proxies_controller_test.rb b/test/functional/api/v1/smart_proxies_controller_test.rb
index eaef8ff1c..8401b2fda 100644
--- a/test/functional/api/v1/smart_proxies_controller_test.rb
+++ b/test/functional/api/v1/smart_proxies_controller_test.rb
@@ -9,7 +9,7 @@ class Api::V1::SmartProxiesControllerTest < ActionController::TestCase
     assert_response :success
     assert_not_nil assigns(:smart_proxies)
     smart_proxies = ActiveSupport::JSON.decode(@response.body)
-    assert !smart_proxies.empty?
+    assert_not smart_proxies.empty?
   end
 
   test "should get index filtered by type" do
@@ -19,7 +19,7 @@ class Api::V1::SmartProxiesControllerTest < ActionController::TestCase
     assert_response :success
     assert_not_nil assigns(:smart_proxies)
     smart_proxies = ActiveSupport::JSON.decode(@response.body)
-    assert !smart_proxies.empty?
+    assert_not smart_proxies.empty?
 
     returned_proxy_ids = smart_proxies.map { |p| p["smart_proxy"]["id"] }
     expected_proxy_ids = SmartProxy.tftp_proxies.map { |p| p.id }
@@ -37,7 +37,7 @@ class Api::V1::SmartProxiesControllerTest < ActionController::TestCase
     get :show, { :id => smart_proxies(:one).to_param }
     assert_response :success
     show_response = ActiveSupport::JSON.decode(@response.body)
-    assert !show_response.empty?
+    assert_not show_response.empty?
   end
 
   test "should create smart_proxy" do
diff --git a/test/functional/api/v1/statistics_controller_test.rb b/test/functional/api/v1/statistics_controller_test.rb
index 6fef2a4b5..8a20d5703 100644
--- a/test/functional/api/v1/statistics_controller_test.rb
+++ b/test/functional/api/v1/statistics_controller_test.rb
@@ -7,8 +7,12 @@ class Api::V1::StatisticsControllerTest < ActionController::TestCase
     get :index, { }
     assert_response :success
     response = ActiveSupport::JSON.decode(@response.body)
-    assert !response.empty?
-    assert_equal 'statistics', response.keys.first
+    assert_not response.empty?
+    expected_keys = ["arch_count", "cpu_count", "env_count", "klass_count",
+                     "mem_free", "mem_size", "mem_totfree", "mem_totsize",
+                     "model_count", "os_count", "swap_free", "swap_size"]
+
+    assert_equal expected_keys, response.keys.sort
   end
 
 end
diff --git a/test/functional/api/v1/users_controller_test.rb b/test/functional/api/v1/users_controller_test.rb
index c4bd53f6a..fafe8989f 100644
--- a/test/functional/api/v1/users_controller_test.rb
+++ b/test/functional/api/v1/users_controller_test.rb
@@ -17,14 +17,14 @@ class Api::V1::UsersControllerTest < ActionController::TestCase
     get :show, { :id => users(:one).id }
     assert_response :success
     show_response = ActiveSupport::JSON.decode(@response.body)
-    assert !show_response.empty?
+    assert_not show_response.empty?
   end
 
   test "should show individual record by login name" do
     get :show, { :id => users(:one).login }
     assert_response :success
     show_response = ActiveSupport::JSON.decode(@response.body)
-    assert !show_response.empty?
+    assert_not show_response.empty?
   end
 
   test "should update user" do
diff --git a/test/functional/api/v2/compute_resources_controller_test.rb b/test/functional/api/v2/compute_resources_controller_test.rb
index c56148f8e..b60d0b3c6 100644
--- a/test/functional/api/v2/compute_resources_controller_test.rb
+++ b/test/functional/api/v2/compute_resources_controller_test.rb
@@ -48,59 +48,52 @@ class Api::V2::ComputeResourcesControllerTest < ActionController::TestCase
   end
 
   test "should get index of owned" do
-    as_user(:restricted) do
-      get :index, {}
-    end
+    setup_user 'view', 'compute_resources', "id = #{compute_resources(:mycompute).id}"
+    get :index, {}
     assert_response :success
     assert_not_nil assigns(:compute_resources)
     compute_resources = ActiveSupport::JSON.decode(@response.body)
     ids               = compute_resources['results'].map { |hash| hash['id'] }
-    assert !ids.include?(compute_resources(:mycompute).id)
-    assert ids.include?(compute_resources(:yourcompute).id)
+    assert_includes ids, compute_resources(:mycompute).id
+    refute_includes ids, compute_resources(:yourcompute).id
   end
 
   test "should allow access to a compute resource for owner" do
-    as_user(:restricted) do
-      get :show, { :id => compute_resources(:yourcompute).to_param }
-    end
+    setup_user 'view', 'compute_resources', "id = #{compute_resources(:mycompute).id}"
+    get :show, { :id => compute_resources(:mycompute).to_param }
     assert_response :success
   end
 
   test "should update compute resource for owner" do
-    as_user(:restricted) do
-      put :update, { :id => compute_resources(:yourcompute).to_param, :compute_resource => { :description => "new_description" } }
-    end
-    assert_equal "new_description", ComputeResource.find_by_name('yourcompute').description
+    setup_user 'edit', 'compute_resources', "id = #{compute_resources(:mycompute).id}"
+    put :update, { :id => compute_resources(:mycompute).to_param, :compute_resource => { :description => "new_description" } }
+    assert_equal "new_description", ComputeResource.find_by_name('mycompute').description
     assert_response :success
   end
 
   test "should destroy compute resource for owner" do
     assert_difference('ComputeResource.count', -1) do
-      as_user(:restricted) do
-        delete :destroy, { :id => compute_resources(:yourcompute).id }
-      end
+      setup_user 'destroy', 'compute_resources', "id = #{compute_resources(:mycompute).id}"
+      delete :destroy, { :id => compute_resources(:mycompute).id }
     end
     assert_response :success
   end
 
   test "should not allow access to a compute resource out of users compute resources scope" do
-    as_user(:restricted) do
-      get :show, { :id => compute_resources(:one).to_param }
-    end
+    setup_user 'view', 'compute_resources', "id = #{compute_resources(:mycompute).id}"
+    get :show, { :id => compute_resources(:one).to_param }
     assert_response :not_found
   end
 
   test "should not update compute resource for restricted" do
-    as_user(:restricted) do
-      put :update, { :id => compute_resources(:mycompute).to_param, :compute_resource => { :description => "new_description" } }
-    end
+    setup_user 'edit', 'compute_resources', "id = #{compute_resources(:mycompute).id}"
+    put :update, { :id => compute_resources(:yourcompute).to_param, :compute_resource => { :description => "new_description" } }
     assert_response :not_found
   end
 
   test "should not destroy compute resource for restricted" do
-    as_user(:restricted) do
-      delete :destroy, { :id => compute_resources(:mycompute).id }
-    end
+    setup_user 'destroy', 'compute_resources', "id = #{compute_resources(:mycompute).id}"
+    delete :destroy, { :id => compute_resources(:yourcompute).id }
     assert_response :not_found
   end
 
@@ -115,7 +108,7 @@ class Api::V2::ComputeResourcesControllerTest < ActionController::TestCase
     get :available_images, { :id => compute_resources(:ec2).to_param }
     assert_response :success
     available_images = ActiveSupport::JSON.decode(@response.body)
-    assert !available_images.empty?
+    assert_not_empty available_images
   end
 
   test "should get available networks" do
diff --git a/test/functional/api/v2/filters_controller_test.rb b/test/functional/api/v2/filters_controller_test.rb
new file mode 100644
index 000000000..448871495
--- /dev/null
+++ b/test/functional/api/v2/filters_controller_test.rb
@@ -0,0 +1,40 @@
+require 'test_helper'
+
+class Api::V2::FiltersControllerTest < ActionController::TestCase
+
+  test "should get index" do
+    get :index
+    assert_response :success
+    assert_not_nil assigns(:filters)
+    filters = ActiveSupport::JSON.decode(@response.body)
+    assert !filters.empty?
+  end
+
+  test "should show individual record" do
+    get :show, { :id => filters(:manager_1).to_param }
+    assert_response :success
+    show_response = ActiveSupport::JSON.decode(@response.body)
+    assert !show_response.empty?
+  end
+
+  test "should create filter" do
+    valid_attrs = { :role_id => roles(:manager).id, :permission_ids => [permissions(:view_architectures).id]  }
+    assert_difference('Filter.count') do
+      post :create, { :filter => valid_attrs }
+    end
+    assert_response :success
+  end
+
+  test "should update filter" do
+    put :update, { :id => filters(:manager_1).to_param, :filter => { } }
+    assert_response :success
+  end
+
+  test "should destroy filters" do
+    assert_difference('Filter.count', -1) do
+      delete :destroy, { :id => filters(:crud_hosts_1).to_param }
+    end
+    assert_response :success
+  end
+
+end
diff --git a/test/functional/api/v2/hosts_controller_test.rb b/test/functional/api/v2/hosts_controller_test.rb
index 17d368d0c..663e076b0 100644
--- a/test/functional/api/v2/hosts_controller_test.rb
+++ b/test/functional/api/v2/hosts_controller_test.rb
@@ -74,72 +74,63 @@ class Api::V2::HostsControllerTest < ActionController::TestCase
   end
 
   test "should allow access to restricted user who owns the host" do
-    as_user :restricted do
-      get :show, { :id => hosts(:owned_by_restricted).to_param }
-    end
+    setup_user 'view', 'hosts', "owner_type = User and owner_id = #{users(:restricted).id}", :restricted
+    get :show, { :id => hosts(:owned_by_restricted).to_param }
     assert_response :success
   end
 
   test "should allow to update for restricted user who owns the host" do
     disable_orchestration
-    as_user :restricted do
-      put :update, { :id => hosts(:owned_by_restricted).to_param, :host => {} }
-    end
+    setup_user 'edit', 'hosts', "owner_type = User and owner_id = #{users(:restricted).id}", :restricted
+    put :update, { :id => hosts(:owned_by_restricted).to_param, :host => {} }
     assert_response :success
   end
 
   test "should allow destroy for restricted user who owns the hosts" do
     assert_difference('Host.count', -1) do
-      as_user :restricted do
-        delete :destroy, { :id => hosts(:owned_by_restricted).to_param }
-      end
+      setup_user 'destroy', 'hosts', "owner_type = User and owner_id = #{users(:restricted).id}", :restricted
+      delete :destroy, { :id => hosts(:owned_by_restricted).to_param }
     end
     assert_response :success
   end
 
   test "should allow show status for restricted user who owns the hosts" do
-    as_user :restricted do
-      get :status, { :id => hosts(:owned_by_restricted).to_param }
-    end
+    setup_user 'view', 'hosts', "owner_type = User and owner_id = #{users(:restricted).id}", :restricted
+    get :status, { :id => hosts(:owned_by_restricted).to_param }
     assert_response :success
   end
 
   test "should not allow access to a host out of users hosts scope" do
-    as_user :restricted do
-      get :show, { :id => hosts(:one).to_param }
-    end
+    setup_user 'view', 'hosts', "owner_type = User and owner_id = #{users(:restricted).id}", :restricted
+    get :show, { :id => hosts(:one).to_param }
     assert_response :not_found
   end
 
   test "should not list a host out of users hosts scope" do
-    as_user :restricted do
-      get :index, {}
-    end
+    setup_user 'view', 'hosts', "owner_type = User and owner_id = #{users(:restricted).id}", :restricted
+    get :index, {}
     assert_response :success
     hosts = ActiveSupport::JSON.decode(@response.body)
     ids = hosts['results'].map { |hash| hash['id'] }
-    assert !ids.include?(hosts(:one).id)
-    assert ids.include?(hosts(:owned_by_restricted).id)
+    refute_includes ids, hosts(:one).id
+    assert_includes ids, hosts(:owned_by_restricted).id
   end
 
   test "should not update host out of users hosts scope" do
-    as_user :restricted do
-      put :update, { :id => hosts(:one).to_param }
-    end
+    setup_user 'edit', 'hosts', "owner_type = User and owner_id = #{users(:restricted).id}", :restricted
+    put :update, { :id => hosts(:one).to_param }
     assert_response :not_found
   end
 
   test "should not delete hosts out of users hosts scope" do
-    as_user :restricted do
-      delete :destroy, { :id => hosts(:one).to_param }
-    end
+    setup_user 'destroy', 'hosts', "owner_type = User and owner_id = #{users(:restricted).id}", :restricted
+    delete :destroy, { :id => hosts(:one).to_param }
     assert_response :not_found
   end
 
   test "should not show status of hosts out of users hosts scope" do
-    as_user :restricted do
-      get :status, { :id => hosts(:one).to_param }
-    end
+    setup_user 'view', 'hosts', "owner_type = User and owner_id = #{users(:restricted).id}", :restricted
+    get :status, { :id => hosts(:one).to_param }
     assert_response :not_found
   end
 
diff --git a/test/functional/api/v2/operatingsystems_controller_test.rb b/test/functional/api/v2/operatingsystems_controller_test.rb
index 599df67ad..7d284403c 100644
--- a/test/functional/api/v2/operatingsystems_controller_test.rb
+++ b/test/functional/api/v2/operatingsystems_controller_test.rb
@@ -54,7 +54,6 @@ class Api::V2::OperatingsystemsControllerTest < ActionController::TestCase
 
   test "should update associated architectures by ids" do
     os = operatingsystems(:redhat)
-    puts
     assert_difference('os.architectures.count') do
       put :update, { :id => operatingsystems(:redhat).to_param, :operatingsystem => { },
                      :architectures => [{ :id => architectures(:x86_64).id }, { :id => architectures(:sparc).id } ]
@@ -65,7 +64,6 @@ class Api::V2::OperatingsystemsControllerTest < ActionController::TestCase
 
   test "should update associated architectures by name" do
     os = operatingsystems(:redhat)
-    puts
     assert_difference('os.architectures.count') do
       put :update, { :id => operatingsystems(:redhat).to_param,  :operatingsystem => { },
                      :architectures => [{ :name => architectures(:x86_64).name }, { :name => architectures(:sparc).name } ]
diff --git a/test/functional/api/v2/override_values_controller_test.rb b/test/functional/api/v2/override_values_controller_test.rb
index da3976aa0..041d5ff3e 100644
--- a/test/functional/api/v2/override_values_controller_test.rb
+++ b/test/functional/api/v2/override_values_controller_test.rb
@@ -9,14 +9,14 @@ class Api::V2::OverrideValuesControllerTest < ActionController::TestCase
     get :index, {:smart_variable_id => lookup_keys(:two).to_param }
     assert_response :success
     override_values = ActiveSupport::JSON.decode(@response.body)
-    assert !override_values.empty?
+    assert_not_empty override_values
     assert_equal 1, override_values["results"].length
   end
   test "should get override values for specific smart class parameter" do
     get :index, {:smart_class_parameter_id => lookup_keys(:complex).to_param }
     assert_response :success
     override_values = ActiveSupport::JSON.decode(@response.body)
-    assert !override_values.empty?
+    assert_not_empty override_values
     assert_equal 2, override_values["results"].length
   end
 
@@ -37,13 +37,13 @@ class Api::V2::OverrideValuesControllerTest < ActionController::TestCase
     get :show,  {:smart_variable_id => lookup_keys(:two).to_param, :id => lookup_values(:four).to_param }
     assert_response :success
     results = ActiveSupport::JSON.decode(@response.body)
-    assert !results.empty?
+    assert_not_empty results
     assert_equal "hostgroup=Common", results['match']
   end
   test "should show specific override values for specific smart class parameter" do
     get :show,  {:smart_class_parameter_id => lookup_keys(:complex).to_param, :id => lookup_values(:hostgroupcommon).to_param }
     results = ActiveSupport::JSON.decode(@response.body)
-    assert !results.empty?
+    assert_not_empty results
     assert_equal "hostgroup=Common", results['match']
     assert_response :success
   end
@@ -60,4 +60,4 @@ class Api::V2::OverrideValuesControllerTest < ActionController::TestCase
     assert_response :success
   end
 
-end
\ No newline at end of file
+end
diff --git a/test/functional/api/v2/parameters_controller_test.rb b/test/functional/api/v2/parameters_controller_test.rb
index 9a1f74db7..7d8268f2b 100644
--- a/test/functional/api/v2/parameters_controller_test.rb
+++ b/test/functional/api/v2/parameters_controller_test.rb
@@ -9,7 +9,7 @@ class Api::V2::ParametersControllerTest < ActionController::TestCase
     assert_response :success
     assert_not_nil assigns(:parameters)
     parameters = ActiveSupport::JSON.decode(@response.body)
-    assert !parameters.empty?
+    assert_not_empty parameters
   end
 
   test "should get index for specific domain" do
@@ -17,7 +17,7 @@ class Api::V2::ParametersControllerTest < ActionController::TestCase
     assert_response :success
     assert_not_nil assigns(:parameters)
     parameters = ActiveSupport::JSON.decode(@response.body)
-    assert !parameters.empty?
+    assert_not_empty parameters
   end
 
   test "should get index for specific hostgroup" do
@@ -25,7 +25,7 @@ class Api::V2::ParametersControllerTest < ActionController::TestCase
     assert_response :success
     assert_not_nil assigns(:parameters)
     parameters = ActiveSupport::JSON.decode(@response.body)
-    assert !parameters.empty?
+    assert_not_empty parameters
   end
 
 
@@ -34,35 +34,35 @@ class Api::V2::ParametersControllerTest < ActionController::TestCase
     assert_response :success
     assert_not_nil assigns(:parameters)
     parameters = ActiveSupport::JSON.decode(@response.body)
-    assert !parameters.empty?
+    assert_not_empty parameters
   end
 
   test "should show a host parameter" do
     get :show, { :host_id => hosts(:one).to_param, :id => parameters(:host).to_param }
     assert_response :success
     show_response = ActiveSupport::JSON.decode(@response.body)
-    assert !show_response.empty?
+    assert_not_empty show_response
   end
 
   test "should show a domain parameter" do
     get :show, {:domain_id => domains(:mydomain).to_param, :id => parameters(:domain).to_param }
     assert_response :success
     show_response = ActiveSupport::JSON.decode(@response.body)
-    assert !show_response.empty?
+    assert_not_empty show_response
   end
 
   test "should show a hostgroup parameter" do
     get :show, {:hostgroup_id => hostgroups(:common).to_param,:id => parameters(:group).to_param }
     assert_response :success
     show_response = ActiveSupport::JSON.decode(@response.body)
-    assert !show_response.empty?
+    assert_not_empty show_response
   end
 
   test "should show an os parameter" do
     get :show, {:operatingsystem_id => operatingsystems(:redhat).to_param,:id => parameters(:os).to_param }
     assert_response :success
     show_response = ActiveSupport::JSON.decode(@response.body)
-    assert !show_response.empty?
+    assert_not_empty show_response
   end
 
   test "should show correct parameter if id is name even if name is not unique" do
diff --git a/test/functional/api/v2/statistics_controller_test.rb b/test/functional/api/v2/statistics_controller_test.rb
index e07b40a40..fff25a27d 100644
--- a/test/functional/api/v2/statistics_controller_test.rb
+++ b/test/functional/api/v2/statistics_controller_test.rb
@@ -6,19 +6,12 @@ class Api::V2::StatisticsControllerTest < ActionController::TestCase
     get :index, { }
     assert_response :success
     response = ActiveSupport::JSON.decode(@response.body)
-    assert !response.empty?
-    assert response.keys.include?('os_count')
-    assert response.keys.include?('arch_count')
-    assert response.keys.include?('env_count')
-    assert response.keys.include?('klass_count')
-    assert response.keys.include?('cpu_count')
-    assert response.keys.include?('model_count')
-    assert response.keys.include?('mem_size')
-    assert response.keys.include?('mem_free')
-    assert response.keys.include?('swap_size')
-    assert response.keys.include?('swap_free')
-    assert response.keys.include?('mem_totsize')
-    assert response.keys.include?('mem_totfree')
+    assert_not response.empty?
+    expected_keys = ["arch_count", "cpu_count", "env_count", "klass_count",
+                     "mem_free", "mem_size", "mem_totfree", "mem_totsize",
+                     "model_count", "os_count", "swap_free", "swap_size"]
+
+    assert_equal expected_keys, response.keys.sort
   end
 
 end
diff --git a/test/functional/api/v2/users_controller_test.rb b/test/functional/api/v2/users_controller_test.rb
index cf58ee57b..f7b8e5f33 100644
--- a/test/functional/api/v2/users_controller_test.rb
+++ b/test/functional/api/v2/users_controller_test.rb
@@ -17,14 +17,14 @@ class Api::V2::UsersControllerTest < ActionController::TestCase
     get :show, { :id => users(:one).id }
     assert_response :success
     show_response = ActiveSupport::JSON.decode(@response.body)
-    assert !show_response.empty?
+    assert_not show_response.empty?
   end
 
   test "should show individual record by login name" do
     get :show, { :id => users(:one).login }
     assert_response :success
     show_response = ActiveSupport::JSON.decode(@response.body)
-    assert !show_response.empty?
+    assert_not show_response.empty?
   end
 
   test "should update user" do
diff --git a/test/functional/compute_resources_controller_test.rb b/test/functional/compute_resources_controller_test.rb
index 13c90830a..2ff9fa093 100644
--- a/test/functional/compute_resources_controller_test.rb
+++ b/test/functional/compute_resources_controller_test.rb
@@ -59,7 +59,7 @@ class ComputeResourcesControllerTest < ActionController::TestCase
   test "should not show compute resource when restricted" do
     setup_user "view"
     get :show, {:id => @your_compute_resource.to_param}, set_session_user
-    assert_response 403
+    assert_response 404
   end
 
   test "should show compute resource" do
@@ -77,7 +77,7 @@ class ComputeResourcesControllerTest < ActionController::TestCase
   test "should not get edit when restricted" do
     setup_user "edit"
     get :edit, {:id => @your_compute_resource.to_param}, set_session_user
-    assert_response 403
+    assert_response 404
   end
 
   test "should get edit" do
@@ -95,7 +95,7 @@ class ComputeResourcesControllerTest < ActionController::TestCase
   test "should not update compute resource when restricted" do
     setup_user "edit"
     put :update, {:id => @your_compute_resource.to_param, :compute_resource => {:name => "editing_self", :provider => "EC2"}}, set_session_user
-    assert_response 403
+    assert_response 404
   end
 
   test "should update compute resource" do
@@ -119,7 +119,7 @@ class ComputeResourcesControllerTest < ActionController::TestCase
       delete :destroy, {:id => @your_compute_resource.to_param}, set_session_user
     end
 
-    assert_response 403
+    assert_response 404
   end
 
   test "should destroy compute resource" do
@@ -154,18 +154,8 @@ class ComputeResourcesControllerTest < ActionController::TestCase
     SETTINGS[:login] ? {:user => User.current.id, :expires_at => 5.minutes.from_now} : {}
   end
 
-  def setup_user operation
-    @one = users(:one)
-    @request.session[:user] = @one.id
-    as_admin do
-      @one.roles = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
-      role = Role.find_or_create_by_name :name => "#{operation}_compute_resources"
-      role.permissions = ["#{operation}_compute_resources".to_sym]
-      role.save!
-      @one.roles << [role]
-      @one.compute_resources = [@compute_resource]
-      @one.save!
-    end
-    User.current = @one
+  def setup_user operation, type = 'compute_resources'
+    super(operation, type, "id = #{@compute_resource.id}")
   end
+
 end
